diff -pruN 3~git20240319~18b2816+ds-1/CMakeLists.txt 3~git20240508~ff62eb6+ds-1/CMakeLists.txt
--- 3~git20240319~18b2816+ds-1/CMakeLists.txt	2024-03-19 04:57:53.000000000 +0000
+++ 3~git20240508~ff62eb6+ds-1/CMakeLists.txt	2024-05-08 17:01:04.000000000 +0000
@@ -69,7 +69,7 @@ cmake_dependent_option(BUILD_SHARED_LIBS
 
 cmake_dependent_option(SDL3IMAGE_INSTALL "Enable SDL3_image install target" ${SDL3IMAGE_ROOTPROJECT} "${sdl3image_install_enableable}" OFF)
 cmake_dependent_option(SDL3IMAGE_INSTALL_CPACK "Create binary SDL3_image archive using CPack" ${SDL3IMAGE_ROOTPROJECT} "SDL3IMAGE_INSTALL" OFF)
-cmake_dependent_option(SDL3IMAGE_INSTALL_MAN "Install man pages for SDL3_image" ${SDL3IMAGE_ROOTPROJECT} "SDL3IMAGE_INSTALL" OFF)
+cmake_dependent_option(SDL3IMAGE_INSTALL_MAN "Install man pages for SDL3_image" OFF "SDL3IMAGE_INSTALL" OFF)
 cmake_dependent_option(SDL3IMAGE_DEPS_SHARED "Load dependencies dynamically" ON PLATFORM_SUPPORTS_SHARED OFF)
 option(SDL3IMAGE_VENDORED "Use vendored third-party libraries" ${vendored_default})
 option(SDL3IMAGE_WERROR "Treat warnings as errors" OFF)
@@ -166,7 +166,7 @@ endif()
 cmake_dependent_option(SDL3IMAGE_PNG_SHARED "Dynamically load PNG support (requires shared libpng)"
     ${SDL3IMAGE_DEPS_SHARED} "SDL3IMAGE_PNG;NOT SDL3IMAGE_BACKEND_WIC;NOT SDL3IMAGE_BACKEND_STB;NOT SDL3IMAGE_BACKEND_IMAGEIO" OFF)
 
-if(SDL3IMAGE_VENDORED AND SDL3IMAGE_TIF)
+if(SDL3IMAGE_VENDORED AND SDL3IMAGE_TIF AND NOT (SDL3IMAGE_BACKEND_IMAGEIO OR SDL3IMAGE_BACKEND_WIC))
     set(SDL3IMAGE_TIF_VENDORED ON)
 else()
     set(SDL3IMAGE_TIF_VENDORED OFF)
@@ -307,19 +307,17 @@ endif()
 sdl_target_link_option_version_file(${sdl3_image_target_name} "${CMAKE_CURRENT_SOURCE_DIR}/src/SDL_image.sym")
 
 if(NOT ANDROID)
+    set_target_properties(${sdl3_image_target_name} PROPERTIES
+        SOVERSION "${SO_VERSION_MAJOR}"
+        VERSION "${SO_VERSION}"
+    )
     if(APPLE)
-        # the SOVERSION property corresponds to the compatibility version and VERSION corresponds to the current version
-        # https://cmake.org/cmake/help/latest/prop_tgt/SOVERSION.html#mach-o-versions
+        cmake_minimum_required(VERSION 3.17)
         set_target_properties(${sdl3_image_target_name} PROPERTIES
-            SOVERSION "${DYLIB_COMPAT_VERSION}"
-            VERSION "${DYLIB_CURRENT_VERSION}"
+            MACHO_COMPATIBILITY_VERSION "${DYLIB_COMPAT_VERSION}"
+            MACHO_CURRENT_VERSION "${DYLIB_CURRENT_VERSION}"
         )
         sdl_no_deprecated_errors(${sdl3_image_target_name})
-    else()
-        set_target_properties(${sdl3_image_target_name} PROPERTIES
-            SOVERSION "${SO_VERSION_MAJOR}"
-            VERSION "${SO_VERSION}"
-        )
     endif()
 endif()
 if(SDL3IMAGE_BUILD_SHARED_LIBS)
@@ -488,6 +486,7 @@ if(SDL3IMAGE_AVIF)
         set(SDL3IMAGE_AVIF_ENABLED TRUE)
         message(STATUS "${PROJECT_NAME}: Using vendored libavif")
         sdl_check_project_in_subfolder(external/libavif libavif SDL3IMAGE_VENDORED)
+        set(SKIP_INSTALL_LIBRARIES TRUE)
         set(BUILD_SHARED_LIBS ${SDL3IMAGE_AVIF_SHARED})
         set(AVIF_CODEC_DAV1D ON CACHE BOOL "Use dav1d codec for decoding" FORCE)
         set(AVIF_LOCAL_DAV1D OFF CACHE BOOL "Build dav1d by libavif" FORCE)
@@ -721,6 +720,7 @@ if(SDL3IMAGE_PNG)
             set(SDL3IMAGE_PNG_ENABLED TRUE)
             message(STATUS "${PROJECT_NAME}: Using vendored libpng")
             set(PNG_TESTS OFF CACHE BOOL "Build PNG Tests" FORCE)
+            set(SKIP_INSTALL_EXPORT TRUE)
             sdl_check_project_in_subfolder(external/libpng libpng SDL3IMAGE_VENDORED)
             add_subdirectory(external/libpng EXCLUDE_FROM_ALL)
             if(SDL3IMAGE_PNG_SHARED)
@@ -813,71 +813,83 @@ endif()
 list(APPEND SDL3IMAGE_BACKENDS TIF)
 set(SDL3IMAGE_TIF_ENABLED FALSE)
 if(SDL3IMAGE_TIF)
-    if(SDL3IMAGE_TIF_VENDORED)
+    if(SDL3IMAGE_BACKEND_IMAGEIO OR SDL3IMAGE_BACKEND_WIC)
         set(SDL3IMAGE_TIF_ENABLED TRUE)
-        message(STATUS "${PROJECT_NAME}: Using vendored libtiff")
-        # tiff-tests variable is used by vendored libtiff
-        set(tiff-tests OFF CACHE BOOL "libtiff: tests" FORCE)
-        # jpeg variable is used by vendored libtiff
-        set(jpeg OFF CACHE BOOL "libtiff: jpeg option" FORCE)
-        # libdeflate variable is used by vendored libtiff
-        set(libdeflate OFF CACHE BOOL "libtiff: libdeflate option" FORCE)
-        # DEFLATE_FOUND variable is used by vendored libtiff
-        set(DEFLATE_FOUND OFF CACHE BOOL "libtiff: libdeflate option" FORCE)
-        # zlib variable is used by vendored libtiff (controls use of `find_package`)
-        set(zlib OFF CACHE BOOL "libtiff: find zlib using find_package" FORCE)
-        # ZLIB_FOUND is used by vendored libtiff
-        set(ZLIB_FOUND "")
-        # lzma variable is used by vendored libtiff
-        set(lzma OFF CACHE BOOL "libtiff: lzma option" FORCE)
-        # webp variable is used by vendored libtiff
-        set(webp OFF CACHE BOOL "libtiff: webp option" FORCE)
-        # zstd variable is used by vendored libtiff
-        set(zstd OFF CACHE BOOL "libtiff: zstd option" FORCE)
-        # ZSTD_FOUND variable is used by vendored libtiff
-        set(ZSTD_FOUND OFF)
-        # WEBP_LIBRARY variable is used by vendored libtiff
-        set(WEBP_LIBRARY "")
-        sdl_check_project_in_subfolder(external/libtiff libtiff SDL3IMAGE_VENDORED)
-        set(BUILD_SHARED_LIBS ${SDL3IMAGE_TIF_SHARED})
-        add_subdirectory(external/libtiff EXCLUDE_FROM_ALL)
-        add_library(TIFF::TIFF ALIAS tiff)
-        if(SDL3IMAGE_TIF_SHARED OR NOT SDL3IMAGE_BUILD_SHARED_LIBS)
-          list(APPEND INSTALL_EXTRA_TARGETS tiff)
-        endif()
-        set_target_properties(tiff PROPERTIES EXPORT_NAME external_libtiff)
-        add_library(SDL3_image::external_libtiff ALIAS tiff)
-        if(NOT SDL3IMAGE_TIF_SHARED)
-            list(APPEND PC_LIBS -l$<TARGET_FILE_BASE_NAME:tiff>)
-        endif()
     else()
-        find_package(TIFF ${required})
-        if(TIFF_FOUND)
-            message(STATUS "${PROJECT_NAME}: Using system libtiff")
+        if(SDL3IMAGE_TIF_VENDORED)
             set(SDL3IMAGE_TIF_ENABLED TRUE)
+            message(STATUS "${PROJECT_NAME}: Using vendored libtiff")
+            # tiff-tests variable is used by vendored libtiff
+            set(tiff-tests OFF CACHE BOOL "libtiff: tests" FORCE)
+            # jpeg variable is used by vendored libtiff
+            set(jpeg OFF CACHE BOOL "libtiff: jpeg option" FORCE)
+            # libdeflate variable is used by vendored libtiff
+            set(libdeflate OFF CACHE BOOL "libtiff: libdeflate option" FORCE)
+            # DEFLATE_FOUND variable is used by vendored libtiff
+            set(DEFLATE_FOUND OFF CACHE BOOL "libtiff: libdeflate option" FORCE)
+            # zlib variable is used by vendored libtiff (controls use of `find_package`)
+            set(zlib OFF CACHE BOOL "libtiff: find zlib using find_package" FORCE)
+            # ZLIB_FOUND is used by vendored libtiff
+            set(ZLIB_FOUND "")
+            # lzma variable is used by vendored libtiff
+            set(lzma OFF CACHE BOOL "libtiff: lzma option" FORCE)
+            # webp variable is used by vendored libtiff
+            set(webp OFF CACHE BOOL "libtiff: webp option" FORCE)
+            # zstd variable is used by vendored libtiff
+            set(zstd OFF CACHE BOOL "libtiff: zstd option" FORCE)
+            # ZSTD_FOUND variable is used by vendored libtiff
+            set(ZSTD_FOUND OFF)
+            # WEBP_LIBRARY variable is used by vendored libtiff
+            set(WEBP_LIBRARY "")
+            sdl_check_project_in_subfolder(external/libtiff libtiff SDL3IMAGE_VENDORED)
+            set(BUILD_SHARED_LIBS ${SDL3IMAGE_TIF_SHARED})
+            add_subdirectory(external/libtiff EXCLUDE_FROM_ALL)
+            add_library(TIFF::TIFF ALIAS tiff)
+            set(SDL2IMAGE_TIF_TARGET "TIFF::tiff")
+            if(SDL3IMAGE_TIF_SHARED OR NOT SDL3IMAGE_BUILD_SHARED_LIBS)
+              list(APPEND INSTALL_EXTRA_TARGETS tiff)
+            endif()
+            set_target_properties(tiff PROPERTIES EXPORT_NAME external_libtiff)
+            add_library(SDL3_image::external_libtiff ALIAS tiff)
             if(NOT SDL3IMAGE_TIF_SHARED)
-                list(APPEND PC_REQUIRES libtiff-4)
+                list(APPEND PC_LIBS -l$<TARGET_FILE_BASE_NAME:tiff>)
             endif()
         else()
-            message(${fatal_error} "libtiff NOT found")
+            find_package(TIFF ${required})
+            if(TIFF_FOUND)
+                message(STATUS "${PROJECT_NAME}: Using system libtiff")
+                set(SDL3IMAGE_TIF_ENABLED TRUE)
+                if(NOT SDL3IMAGE_TIF_SHARED)
+                    list(APPEND PC_REQUIRES libtiff-4)
+                endif()
+                if(TARGET TIFF::tiff)
+                    # introduced in CMake 3.28
+                    # TIFF::TIFF still exists, but it is an INTERFACE library linking to TIFF::tiff (no ALIAS library)
+                    set(SDL2IMAGE_TIF_TARGET "TIFF::tiff")
+                else()
+                    set(SDL2IMAGE_TIF_TARGET "TIFF::TIFF")
+                endif()
+            else()
+                message(${fatal_error} "libtiff NOT found")
+            endif()
         endif()
-    endif()
-    if(SDL3IMAGE_TIF_ENABLED)
-        target_compile_definitions(${sdl3_image_target_name} PRIVATE LOAD_TIF)
-        if(SDL3IMAGE_TIF_SHARED)
-            target_include_directories(${sdl3_image_target_name} PRIVATE
-                $<TARGET_PROPERTY:TIFF::TIFF,INCLUDE_DIRECTORIES>
-                $<TARGET_PROPERTY:TIFF::TIFF,INTERFACE_INCLUDE_DIRECTORIES>
-                $<TARGET_PROPERTY:TIFF::TIFF,INTERFACE_SYSTEM_INCLUDE_DIRECTORIES>
-            )
-            target_get_dynamic_library(dynamic_tif TIFF::TIFF)
-            message(STATUS "Dynamic libtiff: ${dynamic_tif}")
-            target_compile_definitions(${sdl3_image_target_name} PRIVATE "LOAD_TIF_DYNAMIC=\"${dynamic_tif}\"")
-            if(SDL3IMAGE_TIF_VENDORED)
-                add_dependencies(${sdl3_image_target_name} TIFF::TIFF)
+        if(SDL3IMAGE_TIF_ENABLED)
+            target_compile_definitions(${sdl3_image_target_name} PRIVATE LOAD_TIF)
+            if(SDL3IMAGE_TIF_SHARED)
+                target_include_directories(${sdl3_image_target_name} PRIVATE
+                    $<TARGET_PROPERTY:${SDL2IMAGE_TIF_TARGET},INCLUDE_DIRECTORIES>
+                    $<TARGET_PROPERTY:${SDL2IMAGE_TIF_TARGET},INTERFACE_INCLUDE_DIRECTORIES>
+                    $<TARGET_PROPERTY:${SDL2IMAGE_TIF_TARGET},INTERFACE_SYSTEM_INCLUDE_DIRECTORIES>
+                )
+                target_get_dynamic_library(dynamic_tif ${SDL2IMAGE_TIF_TARGET})
+                message(STATUS "Dynamic libtiff: ${dynamic_tif}")
+                target_compile_definitions(${sdl3_image_target_name} PRIVATE "LOAD_TIF_DYNAMIC=\"${dynamic_tif}\"")
+                if(SDL3IMAGE_TIF_VENDORED)
+                    add_dependencies(${sdl3_image_target_name} ${SDL2IMAGE_TIF_TARGET})
+                endif()
+            else()
+                target_link_libraries(${sdl3_image_target_name} PRIVATE ${SDL2IMAGE_TIF_TARGET})
             endif()
-        else()
-            target_link_libraries(${sdl3_image_target_name} PRIVATE TIFF::TIFF)
         endif()
     endif()
 endif()
diff -pruN 3~git20240319~18b2816+ds-1/debian/changelog 3~git20240508~ff62eb6+ds-1/debian/changelog
--- 3~git20240319~18b2816+ds-1/debian/changelog	2024-03-25 18:42:55.000000000 +0000
+++ 3~git20240508~ff62eb6+ds-1/debian/changelog	2024-06-20 13:52:12.000000000 +0000
@@ -1,3 +1,11 @@
+libsdl3-image (3~git20240508~ff62eb6+ds-1) experimental; urgency=medium
+
+  * New upstream snapshot, corresponding to SDL 3.1.2
+    - Depend on a corresponding SDL3 prerelease
+  * d/rules: Build man pages if and only if -doc package is built
+
+ -- Simon McVittie <smcv@debian.org>  Thu, 20 Jun 2024 14:52:12 +0100
+
 libsdl3-image (3~git20240319~18b2816+ds-1) experimental; urgency=medium
 
   * New upstream snapshot
diff -pruN 3~git20240319~18b2816+ds-1/debian/control 3~git20240508~ff62eb6+ds-1/debian/control
--- 3~git20240319~18b2816+ds-1/debian/control	2024-03-25 18:42:55.000000000 +0000
+++ 3~git20240508~ff62eb6+ds-1/debian/control	2024-06-20 13:52:12.000000000 +0000
@@ -6,7 +6,7 @@ Priority: optional
 Rules-Requires-Root: no
 Build-Depends: cmake (>= 3.16),
                debhelper-compat (= 13),
-               libsdl3-dev (>= 3.1.0~),
+               libsdl3-dev (>= 3.1.2~),
                libjpeg-dev,
                libpng-dev,
                libtiff-dev,
@@ -39,7 +39,7 @@ Section: libdevel
 Depends: ${misc:Depends},
          libjpeg-dev,
          libpng-dev,
-         libsdl3-dev (>= 3.1.0~),
+         libsdl3-dev (>= 3.1.2~),
          libsdl3-image0 (= ${binary:Version}),
          libtiff-dev,
          libwebp-dev,
diff -pruN 3~git20240319~18b2816+ds-1/debian/rules 3~git20240508~ff62eb6+ds-1/debian/rules
--- 3~git20240319~18b2816+ds-1/debian/rules	2024-03-25 18:42:55.000000000 +0000
+++ 3~git20240508~ff62eb6+ds-1/debian/rules	2024-06-20 13:52:12.000000000 +0000
@@ -18,6 +18,10 @@ ifneq ($(filter nocheck,$(DEB_BUILD_OPTI
 confflags += -DSDL3IMAGE_TESTS=ON
 endif
 
+ifneq ($(filter %-doc,$(built_binaries)),)
+confflags += -DSDL3IMAGE_INSTALL_MAN=ON
+endif
+
 ifneq ($(filter %-tests,$(built_binaries)),)
 confflags += -DSDL3IMAGE_SAMPLES=ON
 confflags += -DSDL3IMAGE_SAMPLES_INSTALL=ON
diff -pruN 3~git20240319~18b2816+ds-1/examples/showanim.c 3~git20240508~ff62eb6+ds-1/examples/showanim.c
--- 3~git20240319~18b2816+ds-1/examples/showanim.c	2024-03-19 04:57:53.000000000 +0000
+++ 3~git20240508~ff62eb6+ds-1/examples/showanim.c	2024-05-08 17:01:04.000000000 +0000
@@ -83,7 +83,7 @@ int main(int argc, char *argv[])
         return(2);
     }
 
-    if (SDL_CreateWindowAndRenderer(0, 0, flags, &window, &renderer) < 0) {
+    if (SDL_CreateWindowAndRenderer("animation demo", 0, 0, flags, &window, &renderer) < 0) {
         SDL_Log("SDL_CreateWindowAndRenderer() failed: %s\n", SDL_GetError());
         return(2);
     }
diff -pruN 3~git20240319~18b2816+ds-1/include/SDL3_image/SDL_image.h 3~git20240508~ff62eb6+ds-1/include/SDL3_image/SDL_image.h
--- 3~git20240319~18b2816+ds-1/include/SDL3_image/SDL_image.h	2024-03-19 04:57:53.000000000 +0000
+++ 3~git20240508~ff62eb6+ds-1/include/SDL3_image/SDL_image.h	2024-05-08 17:01:04.000000000 +0000
@@ -56,21 +56,22 @@ extern "C" {
 }
 
 #if SDL_IMAGE_MAJOR_VERSION < 3 && SDL_MAJOR_VERSION < 3
+
 /**
- *  This is the version number macro for the current SDL_image version.
+ * This is the version number macro for the current SDL_image version.
  *
- *  In versions higher than 2.9.0, the minor version overflows into
- *  the thousands digit: for example, 2.23.0 is encoded as 4300.
- *  This macro will not be available in SDL 3.x or SDL_image 3.x.
+ * In versions higher than 2.9.0, the minor version overflows into the
+ * thousands digit: for example, 2.23.0 is encoded as 4300. This macro will
+ * not be available in SDL 3.x or SDL_image 3.x.
  *
- *  Deprecated, use SDL_IMAGE_VERSION_ATLEAST or SDL_IMAGE_VERSION instead.
+ * Deprecated, use SDL_IMAGE_VERSION_ATLEAST or SDL_IMAGE_VERSION instead.
  */
 #define SDL_IMAGE_COMPILEDVERSION \
     SDL_VERSIONNUM(SDL_IMAGE_MAJOR_VERSION, SDL_IMAGE_MINOR_VERSION, SDL_IMAGE_PATCHLEVEL)
 #endif /* SDL_IMAGE_MAJOR_VERSION < 3 && SDL_MAJOR_VERSION < 3 */
 
 /**
- *  This macro will evaluate to true if compiled with SDL_image at least X.Y.Z.
+ * This macro will evaluate to true if compiled with SDL_image at least X.Y.Z.
  */
 #define SDL_IMAGE_VERSION_ATLEAST(X, Y, Z) \
     ((SDL_IMAGE_MAJOR_VERSION >= X) && \
@@ -90,7 +91,7 @@ extern DECLSPEC const SDL_Version * SDLC
 /**
  * Initialization flags
  */
-typedef enum
+typedef enum IMG_InitFlags
 {
     IMG_INIT_JPG    = 0x00000001,
     IMG_INIT_PNG    = 0x00000002,
@@ -2082,10 +2083,9 @@ extern DECLSPEC int SDLCALL IMG_SaveJPG(
 extern DECLSPEC int SDLCALL IMG_SaveJPG_IO(SDL_Surface *surface, SDL_IOStream *dst, int closeio, int quality);
 
 /**
- * Animated image support
- * Currently only animated GIFs are supported.
+ * Animated image support Currently only animated GIFs are supported.
  */
-typedef struct
+typedef struct IMG_Animation
 {
 	int w, h;
 	int count;
diff -pruN 3~git20240319~18b2816+ds-1/src/IMG.c 3~git20240508~ff62eb6+ds-1/src/IMG.c
--- 3~git20240319~18b2816+ds-1/src/IMG.c	2024-03-19 04:57:53.000000000 +0000
+++ 3~git20240508~ff62eb6+ds-1/src/IMG.c	2024-05-08 17:01:04.000000000 +0000
@@ -401,7 +401,6 @@ IMG_Animation *IMG_LoadAnimationTyped_IO
             IMG_FreeAnimation(anim);
         }
         SDL_DestroySurface(image);
-        SDL_OutOfMemory();
     }
     return NULL;
 }
diff -pruN 3~git20240319~18b2816+ds-1/src/IMG_gif.c 3~git20240508~ff62eb6+ds-1/src/IMG_gif.c
--- 3~git20240319~18b2816+ds-1/src/IMG_gif.c	2024-03-19 04:57:53.000000000 +0000
+++ 3~git20240508~ff62eb6+ds-1/src/IMG_gif.c	2024-05-08 17:01:04.000000000 +0000
@@ -221,7 +221,6 @@ IMG_LoadGIF_IO_Internal(SDL_IOStream *sr
 
     anim = (Anim_t *)SDL_calloc(1, sizeof(*anim));
     if (!anim) {
-        SDL_OutOfMemory();
         return NULL;
     }
 
@@ -242,7 +241,6 @@ IMG_LoadGIF_IO_Internal(SDL_IOStream *sr
     }
     state = (State_t *)SDL_calloc(1, sizeof(State_t));
     if (state == NULL) {
-        SDL_OutOfMemory();
         goto done;
     }
     state->Gif89.transparent = -1;
@@ -321,7 +319,6 @@ IMG_LoadGIF_IO_Internal(SDL_IOStream *sr
 
             frames = (Frame_t *)SDL_realloc(anim->frames, (anim->count + 1) * sizeof(*anim->frames));
             if (!frames) {
-                SDL_OutOfMemory();
                 goto done;
             }
             ++anim->count;
@@ -729,9 +726,6 @@ IMG_Animation *IMG_LoadGIFAnimation_IO(S
                 anim = NULL;
             }
         }
-        if (!anim) {
-            SDL_OutOfMemory();
-        }
         SDL_free(internal->frames);
         SDL_free(internal);
         return anim;
diff -pruN 3~git20240319~18b2816+ds-1/src/IMG_jpg.c 3~git20240508~ff62eb6+ds-1/src/IMG_jpg.c
--- 3~git20240319~18b2816+ds-1/src/IMG_jpg.c	2024-03-19 04:57:53.000000000 +0000
+++ 3~git20240508~ff62eb6+ds-1/src/IMG_jpg.c	2024-05-08 17:01:04.000000000 +0000
@@ -664,12 +664,14 @@ void IMG_QuitJPG(void)
 /* See if an image is contained in a data source */
 int IMG_isJPG(SDL_IOStream *src)
 {
+    (void)src;
     return(0);
 }
 
 /* Load a JPEG type image from an SDL datasource */
 SDL_Surface *IMG_LoadJPG_IO(SDL_IOStream *src)
 {
+    (void)src;
     return(NULL);
 }
 
@@ -765,6 +767,8 @@ int IMG_SaveJPG(SDL_Surface *surface, co
 int IMG_SaveJPG_IO(SDL_Surface *surface, SDL_IOStream *dst, int closeio, int quality)
 {
     int result = -1;
+    (void)surface;
+    (void)quality;
 
     if (!dst) {
         return IMG_SetError("Passed NULL dst");
diff -pruN 3~git20240319~18b2816+ds-1/src/IMG_jxl.c 3~git20240508~ff62eb6+ds-1/src/IMG_jxl.c
--- 3~git20240319~18b2816+ds-1/src/IMG_jxl.c	2024-03-19 04:57:53.000000000 +0000
+++ 3~git20240508~ff62eb6+ds-1/src/IMG_jxl.c	2024-05-08 17:01:04.000000000 +0000
@@ -98,8 +98,9 @@ int IMG_isJXL(SDL_IOStream *src)
     int is_JXL;
     Uint8 magic[12];
 
-    if ( !src )
+    if (!src) {
         return 0;
+    }
     start = SDL_TellIO(src);
     is_JXL = 0;
     if (SDL_ReadIO(src, magic, 2) == 2 ) {
@@ -174,7 +175,7 @@ SDL_Surface *IMG_LoadJXL_IO(SDL_IOStream
     for ( ; ; ) {
         JxlDecoderStatus status = lib.JxlDecoderProcessInput(decoder);
 
-        switch (status ) {
+        switch (status) {
         case JXL_DEC_ERROR:
             IMG_SetError("JXL decoder error");
             goto done;
@@ -201,7 +202,6 @@ SDL_Surface *IMG_LoadJXL_IO(SDL_IOStream
             }
             pixels = SDL_malloc(outputsize);
             if (!pixels) {
-                SDL_OutOfMemory();
                 goto done;
             }
             if ((outputsize / info.ysize) > SDL_MAX_SINT32) {
diff -pruN 3~git20240319~18b2816+ds-1/test/main.c 3~git20240508~ff62eb6+ds-1/test/main.c
--- 3~git20240319~18b2816+ds-1/test/main.c	2024-03-19 04:57:53.000000000 +0000
+++ 3~git20240508~ff62eb6+ds-1/test/main.c	2024-05-08 17:01:04.000000000 +0000
@@ -79,7 +79,6 @@ GetTestFilename(TestFileType type, const
     if (env != NULL) {
         base = SDL_strdup(env);
         if (base == NULL) {
-            SDL_OutOfMemory();
             return NULL;
         }
     }
@@ -94,9 +93,7 @@ GetTestFilename(TestFileType type, const
         size_t len = SDL_strlen(base) + SDL_strlen(pathsep) + SDL_strlen(file) + 1;
 
         path = SDL_malloc(len);
-
         if (path == NULL) {
-            SDL_OutOfMemory();
             return NULL;
         }
 
@@ -110,7 +107,6 @@ GetTestFilename(TestFileType type, const
     } else {
         path = SDL_strdup(file);
         if (path == NULL) {
-            SDL_OutOfMemory();
             return NULL;
         }
     }
@@ -526,6 +522,7 @@ ConvertToRgba32(SDL_Surface **surface_p)
     if ((*surface_p)->format->format != SDL_PIXELFORMAT_RGBA32) {
         SDL_Surface *temp;
 
+        SDL_ClearError();
         temp = SDL_ConvertSurfaceFormat(*surface_p, SDL_PIXELFORMAT_RGBA32);
         SDLTest_AssertCheck(temp != NULL,
                             "Converting to RGBA should succeed (%s)",
@@ -634,16 +631,21 @@ FormatLoadTest(const Format *format,
     SDL_Surface *reference = NULL;
     SDL_Surface *surface = NULL;
     SDL_IOStream *src = NULL;
-    char *filename = GetTestFilename(TEST_FILE_DIST, format->sample);
-    char *refFilename = GetTestFilename(TEST_FILE_DIST, format->reference);
+    char *filename = NULL;
+    char *refFilename = NULL;
     int initResult = 0;
     int diff;
 
+    SDL_ClearError();
+    filename = GetTestFilename(TEST_FILE_DIST, format->sample);
     if (!SDLTest_AssertCheck(filename != NULL,
                              "Building filename should succeed (%s)",
                              SDL_GetError())) {
         goto out;
     }
+
+    SDL_ClearError();
+    refFilename = GetTestFilename(TEST_FILE_DIST, format->reference);
     if (!SDLTest_AssertCheck(refFilename != NULL,
                              "Building ref filename should succeed (%s)",
                              SDL_GetError())) {
@@ -651,6 +653,7 @@ FormatLoadTest(const Format *format,
     }
 
     if (StrHasSuffix(format->reference, ".bmp")) {
+        SDL_ClearError();
         reference = SDL_LoadBMP(refFilename);
         if (!SDLTest_AssertCheck(reference != NULL,
                                  "Loading reference should succeed (%s)",
@@ -660,6 +663,7 @@ FormatLoadTest(const Format *format,
     }
     else if (StrHasSuffix (format->reference, ".png")) {
 #ifdef LOAD_PNG
+        SDL_ClearError();
         reference = IMG_Load(refFilename);
         if (!SDLTest_AssertCheck(reference != NULL,
                                  "Loading reference should succeed (%s)",
@@ -670,6 +674,7 @@ FormatLoadTest(const Format *format,
     }
 
     if (format->initFlag) {
+        SDL_ClearError();
         initResult = IMG_Init(format->initFlag);
         if (!SDLTest_AssertCheck(initResult != 0,
                                  "Initialization should succeed (%s)",
@@ -682,6 +687,7 @@ FormatLoadTest(const Format *format,
     }
 
     if (mode != LOAD_CONVENIENCE) {
+        SDL_ClearError();
         src = SDL_IOFromFile(filename, "rb");
         SDLTest_AssertCheck(src != NULL,
                             "Opening %s should succeed (%s)",
@@ -690,6 +696,7 @@ FormatLoadTest(const Format *format,
             goto out;
     }
 
+    SDL_ClearError();
     switch (mode) {
         case LOAD_CONVENIENCE:
             surface = IMG_Load(filename);
@@ -721,6 +728,7 @@ FormatLoadTest(const Format *format,
                                     filename, format->name, check);
             }
 
+            SDL_ClearError();
             surface = IMG_Load_IO(src, SDL_TRUE);
             src = NULL;      /* ownership taken */
             break;
@@ -795,7 +803,7 @@ static void
 FormatSaveTest(const Format *format,
                SDL_bool rw)
 {
-    char *refFilename = GetTestFilename(TEST_FILE_DIST, "sample.bmp");
+    char *refFilename = NULL;
     char filename[64] = { 0 };
     SDL_Surface *reference = NULL;
     SDL_Surface *surface = NULL;
@@ -809,12 +817,15 @@ FormatSaveTest(const Format *format,
                  rw ? "Rwops" : "",
                  format->name);
 
+    SDL_ClearError();
+    refFilename = GetTestFilename(TEST_FILE_DIST, "sample.bmp");
     if (!SDLTest_AssertCheck(refFilename != NULL,
                              "Building ref filename should succeed (%s)",
                              SDL_GetError())) {
         goto out;
     }
 
+    SDL_ClearError();
     reference = SDL_LoadBMP(refFilename);
     if (!SDLTest_AssertCheck(reference != NULL,
                              "Loading reference should succeed (%s)",
@@ -823,6 +834,7 @@ FormatSaveTest(const Format *format,
     }
 
     if (format->initFlag) {
+        SDL_ClearError();
         initResult = IMG_Init(format->initFlag);
         if (!SDLTest_AssertCheck(initResult != 0,
                                  "Initialization should succeed (%s)",
@@ -834,6 +846,7 @@ FormatSaveTest(const Format *format,
                             format->initFlag, initResult);
     }
 
+    SDL_ClearError();
     if (SDL_strcmp (format->name, "AVIF") == 0) {
         if (rw) {
             dest = SDL_IOFromFile(filename, "wb");
@@ -866,6 +879,7 @@ FormatSaveTest(const Format *format,
     SDLTest_AssertCheck(result == 0, "Save %s (%s)", filename, SDL_GetError());
 
     if (format->canLoad) {
+        SDL_ClearError();
         surface = IMG_Load(filename);
 
         if (!SDLTest_AssertCheck(surface != NULL,
